"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../service");
var Leaf = require("leaf-ts");
exports.Errors = Leaf.ErrorDoc.create()
    .define("NotAvailable")
    .generate();
var MemoryLockService = (function (_super) {
    __extends(MemoryLockService, _super);
    function MemoryLockService() {
        var _this = _super.call(this) || this;
        _this.locks = {};
        _this.counter = 0;
        return _this;
    }
    MemoryLockService.prototype.lock = function (option, callback) {
        if (!this.locks[option.resource]) {
            var lock = this.locks[option.resource] = Math.random().toString().slice(4);
            callback(null, lock);
        }
        else {
            callback(new exports.Errors.NotAvailable());
        }
    };
    MemoryLockService.prototype.release = function (resource, lock, callback) {
        if (callback === void 0) { callback = function () { }; }
        if (this.locks[resource] !== lock) {
            callback();
            return false;
        }
        this.locks[resource] = null;
        this.counter++;
        if (this.counter >= this.GC_COUNT) {
            this.gc();
        }
        callback();
        return true;
    };
    // defer callback
    MemoryLockService.prototype.defer = function (resource, lock, callback) {
        var _this = this;
        var fn = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            _this.release(resource, lock, function () {
                callback.apply(void 0, args);
            });
        };
        return fn;
    };
    MemoryLockService.prototype.gc = function () {
        var locks = {};
        // Here we don't delege empty field, we just build a new locks.
        // There are usually very few living locks
        for (var prop in this.locks) {
            var v = this.locks[prop];
            if (v) {
                locks[prop] = v;
            }
        }
        this.locks = locks;
    };
    return MemoryLockService;
}(service_1.Service));
exports.MemoryLockService = MemoryLockService;
//# sourceMappingURL=memoryLockService.js.map