import { Service } from "../service"
import * as mongodb from "mongodb"
export class MongodbService extends Service {
    constructor(settings: {
        database: {
            port: number
            name: string
            host: string
        }
    }) {
        super()
        let info = settings.database || {} as any
        this.port = info.port || 27017
        this.dbName = info.name || "test"
        this.host = info.host || "localhost"
    }
    private port: number
    private host: string
    private dbName: string
    name = "MongodbService" as "MongodbService"
    db: mongodb.Db
    initialize(done) {
        console.log("Connecting to database", `mongodb://${this.host}:${this.port}/${this.dbName}`)
        mongodb.MongoClient.connect(`mongodb://${this.host}:${this.port}/${this.dbName}`, (err, db) => {
            this.db = db
            done(err)
        })
    }
    asBuiltIn() {
        console.log(`MongodbService using mongo://${this.host}:${this.port}/${this.dbName}`)
    }
}
