import { DependencyManager } from "./dependency";
import "source-map-support/register";
export declare type ServiceMatcher = string | RegExp;
export declare class ServiceContext {
    private settings;
    private BuiltInServiceInstances;
    constructor(settings?: any);
    services: any | {
        [index: string]: Service;
    };
    dependencyManager: DependencyManager;
    register(s: Service): void;
    supportedLoadExtnames: string[];
    loadServices(path: string): void;
    loadService(path: string): void;
    private isServiceConstructor(obj);
    maxInitializingTimeout: number;
    isSetup: boolean;
    private finishSetup;
    setup(finish?: (err?: Error) => void): void;
    private logInitialized(name);
}
export declare abstract class Service {
    abstract name: string;
    services: any | {
        [index: string]: Service;
    };
    dependencies: ServiceMatcher[];
    isInitialized: boolean;
    initialize(done?: (err?: Error) => void): void;
    constructor(config?: any);
}
